&ANALYZE-SUSPEND _VERSION-NUMBER AB_v10r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
    File        : 
    Purpose     :

    Syntax      :

    Description :

    Author(s)   :
    Created     :
    Notes       :
  ----------------------------------------------------------------------*/
/*          This .W file was created with the Progress AppBuilder.      */
/*----------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-AuthenticateClient) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD AuthenticateClient Procedure 
FUNCTION AuthenticateClient RETURNS LOGICAL
  ( INPUT prSecToken AS RAW)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getDomainAccessKey) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getDomainAccessKey Procedure 
FUNCTION getDomainAccessKey RETURNS CHARACTER
  ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getPBKey) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getPBKey Procedure 
FUNCTION getPBKey RETURNS RAW
  ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 15
         WIDTH              = 60.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

SESSION:ADD-SUPER-PROCEDURE(THIS-PROCEDURE).

SECURITY-POLICY:LOAD-DOMAINS(1) NO-ERROR.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-createCPObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createCPObject Procedure 
PROCEDURE createCPObject :
DEFINE INPUT PARAMETER pcUserID AS CHAR NO-UNDO.
DEFINE INPUT PARAMETER pcWorkStation AS CHAR NO-UNDO.
DEFINE OUTPUT PARAMETER prSecToken AS RAW NO-UNDO.
DEFINE OUTPUT PARAMETER plStatus AS LOGICAL NO-UNDO.

DEFINE VAR hCP AS HANDLE NO-UNDO.
DEFINE VAR rCP AS RAW NO-UNDO.
DEFINE VAR cAccessKey AS CHAR NO-UNDO.
DEFINE VAR rKey AS RAW NO-UNDO.
DEFINE VAR cSecToken AS CHAR NO-UNDO.


rKey =  DYNAMIC-FUNCTION('getPBKey').
cAccessKey = DYNAMIC-FUNCTION('getDomainAccessKey').



SECURITY-POLICY:LOAD-DOMAINS(1) NO-ERROR.
CREATE CLIENT-PRINCIPAL hCP.

hCP:SESSION-ID = BASE64-ENCODE(GENERATE-UUID).
hCP:USER-ID = pcUserID.
hCP:DOMAIN-NAME = 'bravepoint.com'.
hCP:DOMAIN-TYPE = 'Internal'.
hCP:CLIENT-WORKSTATION = pcWorkStation.

hCP:SEAL(cAccessKey).

IF NOT SET-DB-CLIENT(hcp,1) THEN DO:
    hcp:LOGOUT().
    cAccessKey = "".
    plStatus = FALSE.
END.

IF hCP:LOGIN-STATE = "login" THEN DO:
     MESSAGE "Authenticate.p....You are golden:" 
           SKIP "UserID Sports2000: " USERID('sports2000') 
           SKIP "CP UserID:" hCP:USER-ID VIEW-AS ALERT-BOX.
     plStatus = TRUE.
     cSecToken = hCP:SESSION-ID + '|' + cAccessKey.
     prSecToken = ENCRYPT(cSecToken, rKey).
     rCP = hCP:EXPORT-PRINCIPAL().
     CREATE CPObject.
     ASSIGN
         CPObject.SessionID = hCP:SESSION-ID
         CPObject.ContextObject = rCP.
END.

DELETE OBJECT hCP.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-AuthenticateClient) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION AuthenticateClient Procedure 
FUNCTION AuthenticateClient RETURNS LOGICAL
  ( INPUT prSecToken AS RAW) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/


DEFINE VAR hClientPrincipal AS HANDLE NO-UNDO.

DEFINE VAR cAccessCode AS CHAR NO-UNDO.
DEFINE VAR cSessionID AS CHAR NO-UNDO.
DEFINE VAR cAccessKey AS CHAR NO-UNDO.

DEFINE VAR cSecToken AS CHAR NO-UNDO.
DEFINE VAR rKey AS RAW NO-UNDO.

rKey = DYNAMIC-FUNCTION('getPBKey'). 

cSecToken = STRING(DECRYPT(prSecToken, rKey)).

IF cSecToken = "" OR cSecToken = ? THEN RETURN FALSE.


IF NUM-ENTRIES(cSecToken, '|') <> 2 THEN RETURN FALSE.

cSessionID = ENTRY(1,cSecToken,'|').
cAccessKey = ENTRY(2,cSecToken,'|').

CREATE CLIENT-PRINCIPAL hClientPrincipal.

FIND CPObject WHERE CPObject.SessionID = cSessionID NO-LOCK NO-ERROR.
IF NOT AVAIL CPObject THEN DO:
    MESSAGE "No Context set for user." VIEW-AS ALERT-BOX.
    RETURN FALSE.
END.

hClientPrincipal:IMPORT-PRINCIPAL(CPObject.ContextObject).

IF NOT SECURITY-POLICY:SET-CLIENT(hClientPrincipal) THEN DO:
    MESSAGE "Client Principal Object is rotten" VIEW-AS ALERT-BOX.
    RETURN FALSE.
END.



IF NOT hClientPrincipal:VALIDATE-SEAL(cAccessKey) THEN DO:
    MESSAGE "Validate CP, Invalid Acesskey." VIEW-AS ALERT-BOX.
    RETURN FALSE.
END.

DELETE OBJECT hClientPrincipal.

RETURN TRUE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getDomainAccessKey) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getDomainAccessKey Procedure 
FUNCTION getDomainAccessKey RETURNS CHARACTER
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  RETURN "bob".   /* Function return value. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getPBKey) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getPBKey Procedure 
FUNCTION getPBKey RETURNS RAW
  ( /* parameter-definitions */ ) :
/*------------------------------------------------------------------------------
  Purpose:  
    Notes:  
------------------------------------------------------------------------------*/

  RETURN GENERATE-PBE-KEY('plover').

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

