/* getName.p */

DEFINE INPUT PARAMETER pcSecToken AS CHARACTER NO-UNDO.
DEFINE INPUT PARAMETER piCustNum AS INT NO-UNDO.
DEFINE OUTPUT PARAMETER pcResult AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER pcMessage AS CHARACTER NO-UNDO.
DEFINE OUTPUT PARAMETER prCPObject AS RAW NO-UNDO.

DEFINE VAR cAuthCP AS CLASS AuthCP.
DEFINE VARIABLE iErr AS INTEGER NO-UNDO.

cAuthCP = NEW AuthCP().


IF NOT cAuthCP:AuthenticateClient(INPUT pcSecToken,
                                  OUTPUT prCPObject) THEN
    UNDO, THROW NEW Progress.Lang.AppError("Could not Authenticate Client.", 101).
    

FIND customer WHERE customer.custnum = piCustNum NO-LOCK NO-ERROR.
IF AVAIL customer THEN
  pcResult = customer.name.
ELSE
  UNDO, THROW NEW Progress.Lang.AppError('Customer not found.', 100).



CATCH eSysError AS Progress.Lang.Error:
    
    DO iErr = 1 TO eSysError:NumMessages:
        pcMessage = SUBSTITUTE('&1~nErrorNum:&2 &3', pcMessage, 
                                                     eSysError:GetMessageNum(iErr),
                                                     eSysError:GetMessage(iErr)).
    END.
        
END CATCH.
FINALLY:
  IF VALID-OBJECT(cAuthCP) THEN 
    DELETE OBJECT cAuthCP NO-ERROR.        
END FINALLY.